#include <string>
#include "Component.h"
#include <yaml-cpp/yaml.h>

extern "C" {
#include <lua.h>
#include <lualib.h>
#include <lauxlib.h>
}

class ScriptComponent : public Component {
public:
    ScriptComponent(Object* owner);
    ~ScriptComponent();

    void SetScriptPath(const std::string& path);
    const std::string& GetScriptPath() const;

    virtual std::string GetName() const override { return "ScriptComponent"; }
    virtual void Save(YAML::Emitter& out) const override;
    virtual void Load(const YAML::Node& node) override;

    void ReloadScript();
    void OnUpdate(float dt);

private:
    std::string scriptPath;
    lua_State* L;

    void RegisterEngineBindings();
};
